Wordpress Elixir\*
====================

\* Now uses webpack

A base WordPress theme prepped for webpack and npm. If you design and develop custom WordPress themes and hate the cruft logic included in most "base" themes, this is the theme for you. Take it, use it, love it, fork it, make pull requests in the spirit of the theme.

## Quick Start
- Drop the theme into `wp-content/themes`
- Run `npm install`
- Run `webpack`

## About
This theme is designed to wrap all the goodness of [webpack](https://webpack.js.org/), which is a an asset bundler, into a WordPress theme. This allows us to cut down on requests and automate optimization.

## What this isn't
This theme has no opinions on design (though comes with Bootstrap and Font Awesome for example's/convenience's sake). Its opinions lie in an efficient and performant development pattern. For that reason, it's intended to be directly forked as a new theme. This theme works great _as_ a child theme, but it will be difficult to use webpack if you make a child from it.

## Requirements
- Node/npm
- PHP 5.6+ - while WordPress core is comfortable supporting unsupported, unsecure, end-of-life versions of PHP, this theme is not, and the syntax used reflects that.

## Comes With
- Bootstrap
- Font Awesome

Either of these can be replaced or removed entirely. See your `package.json` and edit `main.scss` accordingly.

## Setup
- Drop the theme into `wp-content/themes`
- Run `npm install`

### Installation with Composer
This theme makes use of [`composer/installers`](https://github.com/composer/installers) and its defined WordPress spec. The theme can therefore be installed using `composer require webspec-design/wordpress-elixir` and it will make its way to `wp-content/themes`. However, the theme should be forked following this, or a `composer update` will overwrite your changes. Either remove it from your `composer.json` and `composer.lock` or rename the theme's directory to avoid this.

## Usage
Use `webpack` or `npm run build` to run the webpack file once; or `webpack --watch` or `npm run watch` to run relevant tasks when changes are detected.

### Sass compilation
The webpack setup is designed to compile your sass and any dependencies into one file at `build/css/main.css`, which is already enqueued in the functions file. The theme comes with Bootstrap and a navigation bar to go with it, but you can just as easily swap that out for Foundation or your favorite CSS framework.

#### Importing other sass libraries
- Install: `npm install juice --save`
- Import in `main.scss`: `@import 'node_modules/juice/sass/style.scss'`

#### Install and use a new module
- Install: `npm install scrollmagic --save`
- Use in `main.js`: `var ScrollMagic = require('scrollmagic')`

#### Modularize your own JavaScript
If you like to break your own Javascript into multiple files, you can include them all into your main one by using relative paths:

`require('./maps.js')`

### BrowserSync
Running `webpack --watch` will begin BrowserSync, assuming you've successfully set `bsProxy` in your `env.json` file. This will open a new window in your browser, proxied on port 3000. When the system detects changes to `build/css/main.css`, the styles will be injected into the page. If it detects changes to other file types, the page should refresh automatically.

## Config
If you want to make configurations specific to your development environment or have a place to store sensitive information, consider `env.json` (which should be gitignored, as is the default).

## The `functions.php` file
The functions file is wrapped in a singleton class to avoid polluting the global namespace.

For example's/convenience's sake, the functions file:
  - Defines a navigation menu
  - Defines an image size
  - Declares theme support for title tags and post thumbnails
  - Requires a [custom, Bootstrap-style Walker_Nav_Menu](https://github.com/twittem/wp-bootstrap-navwalker). This is used in `header.php`, so if you remove it here, remove it there
  - Defines a couple convenient constants. They are used elsewhere in the functions file and in `header.php`. If you choose to remove or alter them, do so across the entire theme.
  - Defines a helper function for images. Use this and other static functions you define in this class across your theme like so: `WordPressElixirTheme::image($id, $size='', $icon='', $attr=[]);`.
  - Enqueues jQuery and the scripts and styles generated by Elixir

And that's the theme. Feel free to remove any of it, as this theme is _designed to be forked_ at the outset of development.
